class LogAnalyzer:
    # This should parse the log file named filename, store relevant data in the object,
    # and finally return the number of (non-empty) log lines in the file.
    # See https://en.wikipedia.org/wiki/Common_Log_Format for the format.
    def parse(self, filename):
        return 0

    # The average of object sizes of all requests
    def averageObjectSize(self):
        return 0

    # The most frequent ip address among the log lines.
    # (if multiple exists, just retun any of them)
    def mostFrequentIp(self):
        return "127.0.0.1"

    # Should return a list of all resources requested in sorted order
    def resources(self):
        return []

    # Should return a list of all distinct resources requested in sorted order
    def distinctResources(self):
        return []

    # Should return the number of requests that gave the given HTTP status code.
    def numberOfStatusCode(self, statuscode):
        return 0

    # Should return the number of requests made in the given time range (inclusive start/end).
    # start and end will begiven as datetime objects (described on https://docs.python.org/2/library/datetime.html)
    def countRequestsInTimeRange(self, start, end):
        return 0

    # This function should return a list of resources that fulfill a given criteria in sorted order.
    # To solve this, you must parse the query string part of the resources in the log file.
    # For example the resource /showcars?year=2010&color=red has two query string parameters,
    # one with the name year and value 2010 and one with name color and value red.
    # See more details on https://en.wikipedia.org/wiki/Query_string. 
    # Given a name and value of such a query string parameter, return the list of all
    # resources that match (again in sorted order after resource name).
    def resourcesWithQueryParam(self, name, value):
        return []

    # This is like the previous exercise, except you are now given a list of criterias
    # instead of a single criteria. This function should return a list of all the resources
    # that match _all_ the criterias in the list (again in sorted order after resource name). 
    # The criterias are given as a list of tuples where the first element in the tuple is the
    # name and the second the value. For instance queryParams could be 
    # [("year", "2010"), ("color", "red")].
    def resourcesWithAllQueryParams(self, queryParams):
        return []